<template lang="pug">
<b-modal @show="initImage" @ok="updateSecondaryValue" :id="'edit_image_' + mode + '_' + index" title="新增圖片" title-class="h5" modal-class="edit_modal">
    <b-tabs content-class="p-1">
        <b-tab title="上傳" :active="active === 1" @click="updateActive(1)">
            <dropzone />
        </b-tab>
        <b-tab title="編輯" :active="active === 2" @click.once="refreshImage" @click="updateActive(2)">
            <image_edit ref="image_edit" :default_image="default_image" />
        </b-tab>
        <b-tab title="連結" class="p-2" @click="updateActive(3)">
            <b-form-group id="edit_image_link" label="連結至 :" label-for="edit_image_link_input">
                b-form-input#edit_image_link_input(
                    v-model="url",
                    type="url",
                    placeholder="連結或信箱網址"
                )
            </b-form-group>
            <b-form-group id="edit_image_alt" label="圖片中有什麼？" label-for="edit_image_alt_input">
                b-form-input#edit_image_alt_input(
                    v-model="alt",
                    type="text",
                    placeholder="在這裡新增代替文字"
                )
            </b-form-group>
            <b-form-group id="edit_image_title" label="這個圖片有工具提示嗎？" label-for="edit_image_title_input">
                b-form-input#edit_image_title_input(
                    v-model="title",
                    type="text",
                    placeholder="新增工具提示"
                )
            </b-form-group>
        </b-tab>
    </b-tabs>
</b-modal>
</template>

<script>
import {
    mapGetters
} from "vuex";
import dropzone from "@/components/dropzone/dropzone-image";
import image_edit from "@/components/cropper/C-image";
export default {
    props: {
        mode: {
            type: String,
            default: "",
        },
        index: {
            type: [String, Number],
            default: "",
        },
        default_image: {
            type: String,
        },
    },
    data() {
        return {
            url: "",
            alt: "",
            title: "",
        };
    },
    components: {
        dropzone,
        image_edit,
    },
    computed: {
        ...mapGetters({
            active: "image/active",
            img: "image/temp_img",
        }),
    },
    methods: {
        updateSecondaryValue() {
            this.$root.$emit("send::imageLoad" + this.index, true);
            this.$store.dispatch("image/base64ToImg", this.img.res).then((res) => {
                this.$root.$emit("send::imageLoad" + this.index, false);
                this.$store.commit("UPDATE_SECONDARYCOMPONENT_VALUE", {
                    key: this.index,
                    second_key: "img",
                    val: res,
                });

                this.$store.commit("UPDATE_SECONDARYCOMPONENT_VALUE", {
                    key: this.index,
                    second_key: "url",
                    val: this.url,
                });

                this.$store.commit("UPDATE_SECONDARYCOMPONENT_VALUE", {
                    key: this.index,
                    second_key: "alt",
                    val: this.alt,
                });

                this.$store.commit("UPDATE_SECONDARYCOMPONENT_VALUE", {
                    key: this.index,
                    second_key: "title",
                    val: this.title,
                });

                this.updateActive(1);
            });
        },
        refreshImage() {
            this.$refs.image_edit.refreshImage();
        },
        updateActive(i) {
            this.$store.commit("image/UPDATE_ACTIVE", i);
        },
        initImage() {
            this.$store.commit("image/UPDATE_TEMP_IMAGE", {
                key: "res",
                val: this.default_image,
            });
        },
    },
    mounted() {},
};
</script>

<style lang="scss">
.edit_modal {
    .modal {
        &-header {
            border-bottom: none;
            padding: 10px;
            padding-bottom: 0;
        }

        &-title {
            font-size: 14px !important;
            padding-left: 10px;
        }

        &-body {
            padding: 10px;
        }
    }
}
</style>
